#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector<pair<int,int>> niz(n);
    for(int i = 0;i < n;i++) cin >> niz[i].first >> niz[i].second;

    int mxx = -1,mxy = -1;
    int mnx = 1000001,mny = 1000001;
    for(int i = 0;i < n;i++){
        mnx = min(mnx,niz[i].first);
        mny = min(mny,niz[i].second);
        mxx = max(mxx,niz[i].first);
        mxy = max(mxy,niz[i].second);
        long long ans1 = 0,ans2 = 0,ans3 = 0,ans4 = 0;
        for(int j = 0;j < i;j++){
            ans1 += abs(niz[j].first-mnx)*abs(niz[j].second-mny);
            ans2 += abs(niz[j].first-mxx)*abs(niz[j].second-mxy);
            ans3 += abs(niz[j].first-mxx)*abs(niz[j].second-mny);
            ans4 += abs(niz[j].first-mnx)*abs(niz[j].second-mxy);
        }
        cout << max(ans1,max(ans2,max(ans3,ans4))) << "\n";
    }

    return 0;
}